using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using PTMedicalInsurance.Common;
using PTMedicalInsurance.Helper;
using PTMedicalInsurance.Variables;
using FastReport.Utils;
using Sunny.UI.Win32;
using AnHuiMI.Common;


namespace PTMedicalInsurance.Forms
{
    public partial class OutpatientRegistration : Form
    {
        private InvokeHelper invoker =new InvokeHelper();
        public OutpatientRegistration()
        {
            InitializeComponent();

            this.StartPosition = FormStartPosition.CenterParent;

            if (Global.pat.RYorCY == "2")
            {
                string sqlCondition = " and A.Interface_Dr = '" + Global.inf.interfaceDr.ToString() + "'";

                string sqlStr = " SELECT B.Code,B.Descripts AS Name FROM HB_Dictionary A JOIN HB_DictionaryDataDetail B ON A.ID = B.HBDictionary_Dr  "
                              + " WHERE B.Code='" + Global.pat.insuType + "' and A.InsuCode = 'insutype'" + sqlCondition;
                SetDBLKCombox(ref dblkcbxInsuranceType, sqlStr);

                sqlStr = "select A.Code, A.Name FROM HB_MedInsuDirectory A where A.Code='" + Global.pat.DiseasecCode + "' and A.ValidFlag='1' And A.HisType=7" + sqlCondition;
                SetDBLKCombox(ref dblkcbxDisease, sqlStr);

                sqlStr = " SELECT B.Code,B.Descripts AS Name FROM HB_Dictionary A JOIN HB_DictionaryDataDetail B ON A.ID = B.HBDictionary_Dr"
                       + " WHERE B.Code='" + Global.pat.medType + "' and A.InsuCode = 'med_type'" + sqlCondition;
                SetDBLKCombox(ref dblkcbxMedicalType, sqlStr);

                sqlStr = "SELECT B.Code,B.Descripts AS Name FROM HB_Dictionary A JOIN HB_DictionaryDataDetail B ON A.ID = B.HBDictionary_Dr  WHERE A.InsuCode = 'psn_setlway'" + sqlCondition;
                SetDBLKCombox(ref dblkcbxSettelmentWay, sqlStr);

                //sqlStr = " SELECT B.Code,B.Descripts AS Name FROM HB_Dictionary A JOIN HB_DictionaryDataDetail B ON A.ID = B.HBDictionary_Dr WHERE A.InsuCode = 'IPT_TYPE'" + sqlCondition;
                //SetDBLKCombox(ref dblkcbxHospType, sqlStr);                
                
            }
            else
            {
                string sqlCondition = " and A.Interface_Dr = '" + Global.inf.interfaceDr.ToString() + "'";
                string sqlStr = "SELECT B.Code,B.Descripts AS Name FROM HB_Dictionary A JOIN HB_DictionaryDataDetail B ON A.ID = B.HBDictionary_Dr  WHERE A.InsuCode = 'insutype'" + sqlCondition;
                SetDBLKCombox(ref dblkcbxInsuranceType, sqlStr);

                //sqlStr = "select A.Code, A.Name FROM HB_MedInsuDirectory A where A.ValidFlag='1' And A.HisType=7" + sqlCondition;
                //SetDBLKCombox(ref dblkcbxDisease, sqlStr);

                sqlStr = "SELECT B.Code,B.Descripts AS Name FROM HB_Dictionary A JOIN HB_DictionaryDataDetail B ON A.ID = B.HBDictionary_Dr  WHERE A.InsuCode = 'psn_setlway'" + sqlCondition;
                SetDBLKCombox(ref dblkcbxSettelmentWay, sqlStr);

                sqlStr = "SELECT B.Code,B.Descripts AS Name FROM HB_Dictionary A JOIN HB_DictionaryDataDetail B ON A.ID = B.HBDictionary_Dr  WHERE A.InsuCode = 'med_type'" + sqlCondition;
                SetDBLKCombox(ref dblkcbxMedicalType, sqlStr);

                //sqlStr = " SELECT B.Code,B.Descripts AS Name FROM HB_Dictionary A JOIN HB_DictionaryDataDetail B ON A.ID = B.HBDictionary_Dr WHERE A.InsuCode = 'IPT_TYPE'" + sqlCondition;
                //SetDBLKCombox(ref dblkcbxHospType, sqlStr);

                sqlStr = " SELECT Code, Name,'' as SearchCode  FROM HB_MedInsuDirectory A where A.ValidFlag='1' AND A.HisType=6" + sqlCondition;
                SetDBLKCombox(ref dblkcbxDisease, sqlStr);
            }
                       
        }

        public Boolean b2001 = false;

        private DataTable dtDisease;
        //private DataTable dtDiseaseType;
        //private DataTable dtInsuranceType;
        //private DataTable dtMedicalType;
        //private DataTable dtOperation;
        //private DataTable dtSettelmentType;
        //private DataTable dtHospType;
        //险种
        public string  insuType { get; set; }
        public string insuTypeName { get; set; }
        //医疗类别
        public string med_type { get; set; }
        public string med_type_name { get; set; }
        //诊断
        public string diseCodg { get; set; }
        public string diseName{ get; set; }
        //手术
        public string oprn_oprt_code { get; set; }
        public string oprn_oprt_name{ get; set; }
        //病种
        public string dise_type_code { get; set; }
        public string dise_type_name { get; set; }
        //结算方式
        public string psn_setlway { get; set; }
        public string psn_setlway_name { get; set; }

        public string traumaFlag = "0";
        public string relTtpFlag = "0";
        public string hospType = "0";
        public string otpErReflFlag = "0";
        public string mdtrtGrpType="0";
        public string claTrtFlag = "0";
        public string unifPayStdType = "0";
        public string ouOrEmrefFlag = "0";

        //住院类型
        public string iptTypeCode { get; set; }
        public string iptTypeName { get; set; }

        public DataTable DtDiagnose { get; set; }

        public string personAccountUsedFlag = "0";


        private DataTable GetDBLKComboxTable(string sqlStr)
        {
            InvokeHelper invoker = new InvokeHelper();
            dynamic joInparm = new JObject();
            
            dynamic joTmp = new JObject();
            joTmp.sqlStr = sqlStr;
            JArray jaParams = new JArray();
            jaParams.Add(joTmp);
            joInparm.Add("params", JArray.FromObject(jaParams));
            joInparm.code = "09010014";
            string inParam = joInparm.ToString();
            JObject joRtn = invoker.invokeInsuService(inParam,"获取下拉框消息");
            //dynamic jsonRtn = JsonConvert.DeserializeObject(strRtn);
            DataTable dt = (DataTable)joRtn["result"].ToObject(typeof(DataTable));
            //dt.Columns[0].ColumnName = "编码";
            //dt.Columns[1].ColumnName = "名称";
            //dt.Columns[2].ColumnName = "拼音查找码";
            return dt;
        }
        private void SetDBLKCombox(ref  PTControl.DBLookupCombox dblcbx, string sqlStr)
        {
            dblcbx.sDisplayField = "Code,Name,SearchCode";
            dblcbx.sDisplayMember = "名称";
            dblcbx.sKeyWords = "Code,SearchCode";
            dblcbx.DataSource = GetDBLKComboxTable(sqlStr);
            dblcbx.RowFilterVisible = true;
            dblcbx.TextBox.Width = 400;
            dblcbx.DataGridView.Width = 400;
            dblcbx.DataGridView.Columns[0].Name = "编码";
            dblcbx.DataGridView.Columns[1].Name = "名称";
            dblcbx.DataGridView.Columns[2].Name = "查找码";
            dblcbx.DataGridView.Columns[0].Width = 100;
            dblcbx.DataGridView.Columns[1].Width = 200;
        }
        private void OutpatientRegistration_Load(object sender, EventArgs e)
        {
            dgvDiagnose.AutoGenerateColumns = false;
            dgvDiagnose.DataSource = DtDiagnose;
            //DtDiagnose.AcceptChanges();
            dgvDiagnose.ReadOnly = true;
            cbxAccountPay.Checked = true;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            //DealFor2001("");

            if (cbxMdtrtGrpType.Text != "")
                mdtrtGrpType = (cbxMdtrtGrpType.SelectedIndex).ToString();

            if (dblkcbxOuOrEmref.Text != "")
                ouOrEmrefFlag = (dblkcbxOuOrEmref.SelectedIndex).ToString();

            //外伤标志
            if (Chk_TraumaFlag.Checked)
                traumaFlag = "1";
            else
                traumaFlag = "0";

            //涉及第三方标志
            if (Chk_RelTtpFlag.Checked)
                relTtpFlag = "1";
            else
                relTtpFlag = "0";

            //分级诊疗标志
            if (chk_claTrtFlag.Checked)
                claTrtFlag = "1";
            else
                claTrtFlag = "0";

            //包干标准类型
            if (cbxUnifPayStdType.Text!="")
                unifPayStdType = (cbxUnifPayStdType.SelectedIndex).ToString();

            if (cbxAccountPay.Checked)
            {
                personAccountUsedFlag = "1";
            }
            else
            {
                personAccountUsedFlag = "0";
            }

            hospType = "1";//默认普通住院
            if (dblkcbxHospType.Text != "")
            {
                hospType = (dblkcbxHospType.SelectedIndex).ToString();
            }


                this.DialogResult = DialogResult.OK;
        }

        private void dblkcbxInsuranceType_AfterSelector(object sender, PTControl.AfterSelectorEventArgs e)
        {
            DataGridViewRow row = e.Value as DataGridViewRow;
            DataRowView dataRow = row.DataBoundItem as DataRowView;

            insuType = dataRow["Code"].ToString().Trim();
            insuTypeName = dataRow["Name"].ToString().Trim();
        }

        private void dblkcbxMedicalType_AfterSelector(object sender, PTControl.AfterSelectorEventArgs e)
        {
            DataGridViewRow row = e.Value as DataGridViewRow;
            DataRowView dataRow = row.DataBoundItem as DataRowView;

            med_type = dataRow["Code"].ToString().Trim();
            med_type_name = dataRow["Name"].ToString().Trim();

            if (med_type == "14")
            {
                JObject Jo5301 = new JObject();
                Jo5301.Add("psn_no", Global.pat.psn_no);
                JObject data5301 = new JObject();
                data5301.Add("data", Jo5301);
                JObject Out5301 = new JObject();
                Out5301 = invoker.invokeCenterService("5301", JObject.Parse(JsonHelper.setCenterInpar("5301", data5301)));                
                JArray joMbxx = JArray.Parse(JsonHelper.getDestValue(Out5301, "output.feedetail"));
                if (joMbxx.Count > 0)
                {
                    for (int i = 0; i < joMbxx.Count; i++)
                    {
                        Utils.convertTimestamp((JObject)joMbxx[i], "begndate");
                        Utils.convertTimestamp((JObject)joMbxx[i], "enddate");

                    }
                    MessageBox.Show("人员慢病信息查询结果：" + joMbxx.ToString());
                }
                else
                {
                    MessageBox.Show("人员慢病信息查询结果：" + Out5301.ToString());
                }
                
            }
        }

        private void dblkcbxDisease_AfterSelector(object sender, PTControl.AfterSelectorEventArgs e)
        {
            DataGridViewRow row = e.Value as DataGridViewRow;
            DataRowView dataRow = row.DataBoundItem as DataRowView;

            diseCodg = dataRow["Code"].ToString().Trim();
            diseName = dataRow["Name"].ToString().Trim();
        }

        private void dblkcbxOperation_AfterSelector(object sender, PTControl.AfterSelectorEventArgs e)
        {
            DataGridViewRow row = e.Value as DataGridViewRow;
            DataRowView dataRow = row.DataBoundItem as DataRowView;

            oprn_oprt_code = dataRow["Code"].ToString().Trim();
            oprn_oprt_name = dataRow["Name"].ToString().Trim();
        }

        private void dblkcbxSettelmentWay_AfterSelector(object sender, PTControl.AfterSelectorEventArgs e)
        {
            DataGridViewRow row = e.Value as DataGridViewRow;
            DataRowView dataRow = row.DataBoundItem as DataRowView;

            psn_setlway = dataRow["Code"].ToString().Trim();
            psn_setlway_name = dataRow["Name"].ToString().Trim();
        }

        private void dblkcbxDiseaseType_AfterSelector(object sender, PTControl.AfterSelectorEventArgs e)
        {
            DataGridViewRow row = e.Value as DataGridViewRow;
            DataRowView dataRow = row.DataBoundItem as DataRowView;

            dise_type_code = dataRow["Code"].ToString().Trim();
            dise_type_name = dataRow["Name"].ToString().Trim();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.Cancel;
        }

        private void cbxAccountPay_ValueChanged(object sender, bool value)
        {
            if (cbxAccountPay.Checked)
            {
                personAccountUsedFlag = "1";
            }
            else
            {
                personAccountUsedFlag = "0";
            }
        }

        public int DealFor2001(string funNO, out string OutMsg)
        {
            //人员待遇享受检查
            string errMsg = "";
            JObject joData2001 = new JObject();
            joData2001.Add("psn_no", Global.pat.psn_no);
            joData2001.Add("insutype", insuType);
            joData2001.Add("fixmedins_code", Global.inf.hospitalNO);
            joData2001.Add("med_type", med_type);
            joData2001.Add("begntime", DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss"));
            joData2001.Add("endtime", DateTime.Now.AddDays(1).ToString("yyyy-MM-dd HH:mm:ss"));
            joData2001.Add("dise_codg", diseCodg);
            joData2001.Add("dise_name", diseName);
            joData2001.Add("oprn_oprt_code", "");
            joData2001.Add("oprn_oprt_name", "");
            joData2001.Add("matn_type", "");
            joData2001.Add("birctrl_type", "");
            joData2001.Add("exp_content", "");            

            JObject joInput = new JObject();
            joInput.Add("data", joData2001);
            InvokeHelper invoker = new InvokeHelper();
            JObject joRtn2001 = invoker.invokeCenterService("2001", JsonHelper.setCenterInpar("2001", joInput));

            if (JsonHelper.parseCenterRtnValue(joRtn2001, out errMsg) != 0)
            {
                OutMsg = "人员待遇享受检查调用失败，中心返回错误信息：" + errMsg;
                return -1;
            }
            else
            {
                OutMsg = "人员待遇享受检查调用成功：" + joRtn2001.ToString();
                return 0;
            }
        }

        private void uiButton1_Click(object sender, EventArgs e)
        {
            string OutMsg = "";
            DealFor2001("", out OutMsg);

            MessageBox.Show(OutMsg);
        }

        //private void dblkcbxHospType_AfterSelector(object sender, PTControl.AfterSelectorEventArgs e)
        //{
        //    DataGridViewRow row = e.Value as DataGridViewRow;
        //    DataRowView dataRow = row.DataBoundItem as DataRowView;

        //    iptTypeCode = dataRow["Code"].ToString().Trim();
        //    iptTypeName = dataRow["Name"].ToString().Trim();
        //}

        private void dblkcbxDisease_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

        private void dblkcbxMedicalType_SelectedIndexChanged(object sender, EventArgs e)
        {
            
        }

        private void label10_Click(object sender, EventArgs e)
        {

        }
    }
}
